#% -*- mode: tm; mode: fold -*-

#%{{{Macros 

#i linuxdoc.tm
#d it#1 <it>$1</it>

#d exmp#1 \tt{$1}
#d var#1 \tt{$1}

#d ivar#1 \tt{$1}
#d ifun#1 \tt{$1}
#d cvar#1 \tt{$1}
#d cfun#1 \tt{$1}
#d svar#1 \tt{$1}
#d sfun#1 \tt{$1}
#d icon#1 \tt{$1}
#d dtype#1 \tt{$1}
#d exc#1 \tt{$1}

#d chapter#1 <sect>$1<p>
#d preface <preface>
#d tag#1 <tag>$1</tag>

#d function#1 \sect1{<bf>$1</bf>\label{$1}}<descrip>
#d variable#1 \sect1{<bf>$1</bf>\label{$1}}<descrip>
#d function_sect#1 \sect1{$1}
#d begin_constant_sect#1 \sect1{$1}<itemize>
#d constant#1 <item><tt>$1</tt>
#d end_constant_sect </itemize>

#d synopsis#1 <tag> Synopsis </tag> $1
#d keywords#1 <tag> Keywords </tag> $1
#d usage#1 <tag> Usage </tag> <tt>$1</tt>
#d description <tag> Description </tag>
#d qualifiers <tag> Qualifiers </tag>
#d example <tag> Example </tag>
#d notes <tag> Notes </tag>
#d seealso#1 <tag> See Also </tag> <tt>\linuxdoc_list_to_ref{$1}</tt>
#d done </descrip><p>
#d -1 <tt>-1</tt>
#d 0 <tt>0</tt>
#d 1 <tt>1</tt>
#d 2 <tt>2</tt>
#d 3 <tt>3</tt>
#d 4 <tt>4</tt>
#d 5 <tt>5</tt>
#d 6 <tt>6</tt>
#d 7 <tt>7</tt>
#d 8 <tt>8</tt>
#d 9 <tt>9</tt>
#d NULL <tt>NULL</tt>
#d documentstyle article

#%}}}

#d module#1 \tt{$1}
#d file#1 \tt{$1}
#d slang \url{http://www.jedsoft.org/slang/}{S-lang}
#d slang-documentation \
 \url{http://www.s-lang.org/doc/html/slang.html}{S-Lang documentation}

#d grace_root_url http://plasma-gate.weizmann.ac.il/Grace
#d grace_url \grace_root_url/
#d grace \url{\grace_url}{Grace}
#d graceguide \url{\grace_root_url/doc/UsersGuide.html}{Grace User's Guide}

#d gracemodule-root http://www.jedsoft.org/slang/modules/grace
#d href#1 \url{$1}

#d jed \url{http://www.jedsoft.org/jed/}{jed}
#d slsh \url{http://www.jedsoft.org/slang/slsh.html}{slsh}
#d slrn \url{http://www.slrn.org/jed/}{slrn}

\linuxdoc
\begin{\documentstyle}

\title S-Lang Grace Module Reference
\author John E. Davis, \tt{jed@jedsoft.org}
\date \__today__

#i local.tm

\toc

\chapter{Overview}

\grace (formerly Xmgr) is a popular plotting program for Unix that
features a GUI for WYSIWYG generation of publication quality 2-D
graphs.  The \module{grace-module} provides a high-level interface
between the \slang interpreter and the \grace plotting application,
permitting the creation of multiple \grace instances and allowing an
arbitrary number of \grace windows to be open.

The module was developed and tested with Grace-5.1.20, using Debian
``Etch'' as the underlying OS.  As the module makes extensive use of
qualifiers, it will not work for versions of \slang prior to 2.1.  It
is also unlikely to work with newer development versions of Grace
(grace-6) because the mechanism used for communicating with Grace-5 appears
to be unsupported in Grace-6.  The module interacts with \grace via a
one-way pipe that feeds it commands using the approach recommended in
the \graceguide.  As this pipe is one-way, it is impossible for the
module to query \grace about its plotting state.  For this reason, the
module tries to maintain enough state to avoid potential conflicts
with Grace.  For example, the module will not instruct Grace to switch
to a log scale without first making sure that no negative values have
been plotted. If negative values were plotted, the module will first
change the world-coordinate system to values that are appropriate for
log plots.

The development for this release has been focused towards the types
of 2-D graphs that are common in the physical sciences--- specifically,
Cartesian (X,Y) plots with various combinations of error-bars.  While
the module can be used to produce pie and bar charts, no work has been
done to facilitate the construction of such graphs.  A future version
of the module will address these shortcomings.

\chapter{Tutorial}

A tutorial is available online from
\href{\gracemodule-root/tutorial.html}.  It will not be repeated here.

\chapter{Grace Module Function Reference}
#i gracefuns.tm

\end{\documentstyle}
